package cn.superdesk.uniorder.controller.sys.role;

import cn.superdesk.uniorder.common.json.AnJsonUtils;
import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dao.entity.sys.role.SysRoleExtDataSamplePermission;
import cn.superdesk.uniorder.dto.dubbo.sys.role.SysRoleExtDataSamplePermissionParam;
import cn.superdesk.uniorder.dubbo.consumer.sys.role.SysRoleExtDataSamplePermissionDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;


/**
 * @Description: 角色定义-扩展-数据权限许可(所谓的数据主体) 平铺
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2020-08-26 14:15:28
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020-08-26 14:15:28
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "系统权限-角色(数据权限)-管理许可", tags = {"系统权限-角色(数据权限)-管理许可"})
@Slf4j
@RestController
@RequestMapping("/sysRoleExtDataSamplePermission")
public class SysRoleExtDataSamplePermissionController extends BaseController {

	@Autowired
	private SysRoleExtDataSamplePermissionDubboConsumerService sysRoleExtDataSamplePermissionDubboConsumerService;

	@ApiOperation(value = "分页查询")
	@RequestMapping(value = "list", method = RequestMethod.POST)
	@ResponseBody
	public R<List<SysRoleExtDataSamplePermission>> pageQuerySysRoleExtDataSamplePermissions(@RequestBody PageQueryParam param) {

		log.info("pageQuerySysRoleExtDataSamplePermission:\n{}", AnJsonUtils.toJson(param));

		R<List<SysRoleExtDataSamplePermission>> result = new R<>();

		// TODO 参数合法性判定

		result = sysRoleExtDataSamplePermissionDubboConsumerService.pageQuery(param.getConditions(), param.getPageNo(), param.getPageSize());

		return result;
	}

	@ApiOperation(value = "按id查询")
	@RequestMapping(value = "{id}", method = RequestMethod.GET)
	@ResponseBody
	public R<List<SysRoleExtDataSamplePermission>> getById(@PathVariable("id") long id) {

		R<List<SysRoleExtDataSamplePermission>> result = new R<>();

		// TODO 参数合法性判定

		SysRoleExtDataSamplePermission entity = sysRoleExtDataSamplePermissionDubboConsumerService.findSysRoleExtDataSamplePermissionById(id);

		List<SysRoleExtDataSamplePermission> data = new ArrayList<>();
		data.add(entity);

		result.setData(data);

		return result;
	}

	@ApiOperation(value = "新增")
	@RequestMapping(value = "add", method = RequestMethod.POST)
	@ResponseBody
	public R<String> addSysRoleExtDataSamplePermission(@RequestBody SysRoleExtDataSamplePermissionParam param) {

		log.info("addSysRoleExtDataSamplePermission:\n{}", AnJsonUtils.toJson(param));


		// TODO 参数合法性判定

		sysRoleExtDataSamplePermissionDubboConsumerService.addSysRoleExtDataSamplePermission(param);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "更新")
	@RequestMapping(value = "update", method = RequestMethod.POST)
	@ResponseBody
	public R<String> updateSysRoleExtDataSamplePermission(@RequestBody SysRoleExtDataSamplePermissionParam param) {

		log.info("updateSysRoleExtDataSamplePermission:\n{}", AnJsonUtils.toJson(param));

		sysRoleExtDataSamplePermissionDubboConsumerService.updateSysRoleExtDataSamplePermission(param);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "删除")
	@RequestMapping(value = "delete/{id}", method = RequestMethod.POST)
	@ResponseBody
	public R<String> deleteSysRoleExtDataSamplePermission(@PathVariable("id") long id) {

		// TODO 参数合法性判定

		sysRoleExtDataSamplePermissionDubboConsumerService.deleteSysRoleExtDataSamplePermission(id);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "批量删除")
	@RequestMapping(value = "delete_ids", method = RequestMethod.POST)
	@ResponseBody
	public R<String> deleteIdsSysRoleExtDataSamplePermission(@RequestParam(value = "ids") long[] ids) {

		log.info(AnJsonUtils.toJson(ids));

		for (long id : ids) {
			sysRoleExtDataSamplePermissionDubboConsumerService.deleteSysRoleExtDataSamplePermission(id);
		}

		return new R<>("200", "操作成功", true);

	}


}
